%% Intro
    % Thanks Dr.Dehghanimohammadabadi for developed Matlab-SIMIO API framework.
    % Dr.Dehghanimohammadabadi has the full copyright. 
    % It is extendedly programmed for this study purpose.
    % To run this API framework, full files should be obtained from Dr.Dehghanimohammadabadi(m.dehghani86@gmail.com).
function CallSimio_ForDESPSO(x11,x21,x31,x41,x51,x61,x71,x81,x91,x101)
    clc;   
       
%% Part 1- Simio File Directory Information
    %1-: The Directory that SIMIO file is located
        filePath='C:\test\Part 2'; % user should change it according to your environment  
    %1-2: The name of SIMIO file (*.spfx) 
        fileName='ConcreteConstructionLogicalModelDESPSO2sections.spfx'; % user should change it according to your DES model name
        
%% Part 2- Scenarios
    % Each Schenarion contains 3 pieces of information: 
    %	(1) Scenarion Number
    %   (2) Control Name
    %   (3) Control Value    
    Scenarios=strcat('001;x11;', num2str(x11)...
        ,'|001;x21;', num2str(x21)...
        ,'|001;x31;', num2str(x31)...
        ,'|001;x41;', num2str(x41)...
        ,'|001;x51;', num2str(x51)...
        ,'|001;x61;', num2str(x61)...
        ,'|001;x71;', num2str(x71)...
        ,'|001;x81;', num2str(x81)...
        ,'|001;x91;', num2str(x91)...
        ,'|001;x101;', x101);
%% Part 3- Run Simio Experiment
    % This part runs the SIMIO experiment and prints the results
       
    Results=RunExperiment(filePath, fileName,Scenarios);
            
%% Part 4
    function Results=RunExperiment(filePath, fileName,Scenarios)
        
    % 3-1: Add path
        addpath(filePath)
    %3-1 Clear the txt file content
        TXTfilePathName=strcat(filePath ,'\SimioLink.txt');
        fid=fopen(TXTfilePathName,'wt');
    % Store required info in txt file
        fprintf(fid, '%s\r\n', filePath,fileName, Scenarios);
        fclose(fid);
       
    % Run EXE File to run Experiment
        EXEfilePathName=strcat(filePath ,'\RunExperimentDLLMD.exe');
        system(EXEfilePathName);         
        Results=textread(TXTfilePathName,'%s'); 
        
        global B;
        A={};
        A=Results;
                     
        assignin('base','Results',Results);
        Weizhi = strfind(A{1},';');
        Weizhi2 = Weizhi(2:2:end);
        Weizhi3 = Weizhi(3:2:end);
        Weizhi4 = strfind(A{1},'|');
        
        B =[str2double(A{1}(Weizhi2(1)+1:Weizhi3(1)-1)),str2double(A{1}(Weizhi2(2)+1:Weizhi3(2)-1)),str2double(A{1}(Weizhi2(3)+1:Weizhi4-1))];
        assignin('base','B',B);
        end
end
