%% This code perform PSO

clear
tic
%% Initialization
    No_Call=0;
    nochangeiter=0;
    xh=1;
% Create optimization space
x11=[1:4];x21=[1:4];x31=[1:3];x41=[1:80];x51=[1:3];
x61=[1:3];x71=[1:60];x81=[1:2];x91=[1:2];x101=[1:13];
ind=[];
ind=int8(fullfact([length(x11) length(x21) length(x31) length(x41) length(x51) length(x61) length(x71) length(x81) length(x91) length(x101)]));
Combination=[];
Combination=int8([reshape(x11(ind(:,1)),[],1) reshape(x21(ind(:,2)),[],1) reshape(x31(ind(:,3)),[],1) reshape(x41(ind(:,4)),[],1) reshape(x51(ind(:,5)),[],1) reshape(x61(ind(:,6)),[],1) reshape(x71(ind(:,7)),[],1) reshape(x81(ind(:,8)),[],1) reshape(x91(ind(:,9)),[],1) reshape(x101(ind(:,10)),[],1)]);

Activity=1;     
Stage=1;  
Alternative=[size(Combination,1)]; 

% Give PSO parameter values
xSize=30;  % population
MaxIt=500; % max iteration
c1=0.5;    % acceleration coefficient 
c2=0.5;    % acceleration coefficients 
wmax=1.2;  % dynamic upper inertia factor 
wmin=0.1;  % dynamic lower inertia factor
M=20; % stop replication 

x=[unidrnd(Alternative,xSize,1)];  % initialise random position 
v=zeros(xSize,Activity);      % initialise velocity=0

xbest=x;           % particle best in initialisation
gbest=x(1,:);      % swarm best in initialisation

% particle fitness evaluation initialisation  
px=zeros(1,xSize);   % time performance
rx=zeros(1,xSize);   % environmental performance
cx=zeros(1,xSize);   % cost performance

% particle best record initialisation    
pxbest=zeros(1,xSize); 
rxbest=zeros(1,xSize); 
cxbest=zeros(1,xSize);  

% previous best record initialisation
pxPrior=zeros(1,xSize);
rxPrior=zeros(1,xSize);
cxPrior=zeros(1,xSize);

% generate the first iteration
Time=['WorkSchedule800';'WorkSchedule810';'WorkSchedule820';...
              'WorkSchedule830';'WorkSchedule840';'WorkSchedule850';...
              'WorkSchedule900';'WorkSchedule910';'WorkSchedule920';...
              'WorkSchedule930';'WorkSchedule940';'WorkSchedule950';...
              'WorkSchedule100'];

global B; 
for i=1:xSize
    for j=1:Activity
		x11=Combination(x(i,1),1);x21=Combination(x(i,1),2);x31=Combination(x(i,1),3);
        x41=Combination(x(i,1),4);x51=Combination(x(i,1),5);x61=Combination(x(i,1),6);
        x71=Combination(x(i,1),7);x81=Combination(x(i,1),8);x91=Combination(x(i,1),9);
        x101=Combination(x(i,1),10);
        
        % invoke DES model from SIMIO platform       
        CallSimio_ForDESPSO(x11, x21, x31, x41, x51, x61, x71, x81, x91, Time(x101,:))
        No_Call=No_Call+1; % record times of invoke
        P(x(i,j),j)=B(1,1); % get environment from DES
        px(i) = px(i)+P(x(i,j),j);  % give to particle
        
        R(x(i,j),j)=B(1,2); % get time from DES 
        rx(i) = rx(i)+R(x(i,j),j);  
        
        C(x(i,j),j)=B(1,3); % get cost from DES
        cx(i) = cx(i)+C(x(i,j),j);  
    end
end
% particle best updata
pxbest=px;
rxbest=rx;
cxbest=cx;

% selection from 1st iteration
flj=[];
fljx=[];
fljNum=0;
% threshold
    tolt=1;
    tolc=10;
    tole=1;
% multi-objective domination check
for i=1:xSize
    flag=0; % domination mark  
    for j=1:xSize  
        if j~=i
            if ((px(i)>px(j)) && (rx(i)>rx(j)) && (cx(i)>cx(j))) || ((abs(px(i)-px(j))<tolt)...
                    && (rx(i)>rx(j)) && (cx(i)>cx(j)))||((px(i)>px(j)) && (abs(rx(i)-rx(j))<tole) && (cx(i)>cx(j))) || ((px(i)>px(j)) && (rx(i)>rx(j)) && (cx(i)>cx(j)) && (abs(cx(i)-cx(j))<tolc))
                flag=1;
                break;
            end
        end
    end
    
    if flag==0
        fljNum=fljNum+1;
        % record non-dominated solution
        flj(fljNum,1)=px(i);flj(fljNum,2)=rx(i);flj(fljNum,3)=cx(i);
        fljx(fljNum,:)=x(i,:); 
    end
end

%% iterative loop
for iter=1:MaxIt
    
    % inertia factor updata
    w=wmax-(wmax-wmin)*iter/MaxIt;
     
    % choose the global best particle
    s=size(fljx,1);    
    index=randi(s,1,1);  
    gbest=fljx(index,:);

    %% solution searching
    for i=1:xSize
        % velocity updata 
        v(i,:)=w*v(i,:)+c1*rand(1,1)*(xbest(i,:)-x(i,:))+c2*rand(1,1)*(gbest-x(i,:));
        
        % position updata
        x(i,:)=x(i,:)+v(i,:);
        
        for j=1:Activity
        x(i,j) = rem(x(i,j),Alternative(j))/double(Alternative(j));
         index1=find(x(i,:)<=0);
        
        if ~isempty(index1)
            x(i,index1)=rand(size(index1)); 
        end
        x(i,j)=ceil(Alternative(j)*x(i,j));      
        end
    end
    
    %% fitness evaluation
    pxPrior(:)=0;
    rxPrior(:)=0;
    cxPrior(:)=0;
    for i=1:xSize
        for j=1:Activity 
        x11=Combination(x(i,1),1);x21=Combination(x(i,1),2);x31=Combination(x(i,1),3);
        x41=Combination(x(i,1),4);x51=Combination(x(i,1),5);x61=Combination(x(i,1),6);
        x71=Combination(x(i,1),7);x81=Combination(x(i,1),8);x91=Combination(x(i,1),9);
        x101=Combination(x(i,1),10);
        % invoke DES model and input solutions                
        CallSimio_ForDESPSO(x11, x21, x31, x41, x51, x61, x71, x81, x91, Time(x101,:))              
        No_Call=No_Call+1;
        
        P(x(i,j),j)=B(1,1);
        pxPrior(i) = pxPrior(i)+P(x(i,j),j);  
        
        R(x(i,j),j)=B(1,2);  
        rxPrior(i) = rxPrior(i)+R(x(i,j),j);  
        
        C(x(i,j),j)=B(1,3);  
        cxPrior(i) = cxPrior(i)+C(x(i,j),j);  
        end
    end
    
%% updata particle best record
    for i=1:xSize
        % comparison in multi-objective
          if ((px(i)>pxPrior(i)) && (rx(i)>rxPrior(i))&&(cx(i)>cxPrior(i)))   ||  ((abs(px(i)-pxPrior(i))<tolt)...
                 &&  (rx(i)>rxPrior(i))&&(cx(i)>cxPrior(i)))  ||  ((px(i)>pxPrior(i)) &&  (abs(rx(i)-rxPrior(i))<tole)&&(cx(i)>cxPrior(i)))  || ((px(i)>pxPrior(i)) &&  (abs(cx(i)-cxPrior(i))<tolc)&&(rx(i)>rxPrior(i)))...
				 || ((abs(px(i)-pxPrior(i))<tolt) &&  (abs(rx(i)-rxPrior(i))<tole)&&(cx(i)>cxPrior(i)))...
				 || ((abs(px(i)-pxPrior(i))<tolt) &&  (abs(cx(i)-cxPrior(i))<tolc)&&(rx(i)>rxPrior(i)))...
				 || ((abs(rx(i)-rxPrior(i))<tole) &&  (abs(cx(i)-cxPrior(i))<tolc)&&(px(i)>pxPrior(i)))
                xbest(i,:)=x(i,:);
                pxbest(i)=pxPrior(i);rxbest(i)=rxPrior(i);cxbest(i)=cxPrior(i);
          end
        
        % non-dominated and random select
        if ~( ((px(i)>pxPrior(i)) &&  (rx(i)>rxPrior(i))&&(cx(i)>cxPrior(i))) ||((abs(px(i)-pxPrior(i))<tolt)...
                &&  (rx(i)>rxPrior(i))&&(cx(i)>cxPrior(i)))||((px(i)>pxPrior(i)) &&  (abs(rx(i)-rxPrior(i))<tole)&&(cx(i)>cxPrior(i))) ||((px(i)>pxPrior(i)) &&...
                (abs(cx(i)-cxPrior(i))<tolc)&&(rx(i)>rxPrior(i)))  || ((abs(px(i)-pxPrior(i))<tolt) && (abs(rx(i)-rxPrior(i))<tole)&&(cx(i)>cxPrior(i))) || ((abs(px(i)-pxPrior(i))<tolt) && (abs(cx(i)-cxPrior(i))<tolc)&&(rx(i)>rxPrior(i))) || ((abs(cx(i)-cxPrior(i))<tolc) && (abs(rx(i)-rxPrior(i))<tole)&&(px(i)>pxPrior(i))))...
                &&  ~( ((pxPrior(i)>px(i)) &&  (rxPrior(i)>rx(i)) &&  (cxPrior(i)>cx(i))) ||((abs(pxPrior(i)-px(i))<tolt) &&  (rxPrior(i)>rx(i)) &&  (cxPrior(i)>cx(i)))...
                ||((pxPrior(i)>px(i)) &&  (abs(rxPrior(i)-rx(i))<tole) &&  (cxPrior(i)>cx(i)))||((pxPrior(i)>px(i)) &&  (abs(cxPrior(i)-cx(i))<tolc) &&  (rxPrior(i)>rx(i)))|| ((abs(pxPrior(i)-px(i))<tolt) && (abs(rxPrior(i)-rx(i))<tole)&&(cxPrior(i)>cx(i))) || ((abs(pxPrior(i)-px(i))<tolt) && (abs(cxPrior(i)-cx(i))<tolc)&&(rxPrior(i)>rx(i))) || ((abs(cxPrior(i)-cx(i))<tolc) && (abs(rxPrior(i)-rx(i))<tole)&&(pxPrior(i))>px(i)))
            if rand(1,1)<0.5
                xbest(i,:)=x(i,:);
                  pxbest(i)=pxPrior(i);rxbest(i)=rxPrior(i);cxbest(i)=cxPrior(i);
            end
        end
    end

    px=pxPrior;
    rx=rxPrior;
    cx=cxPrior;
    s=size(flj,1);
   
    pppx=zeros(1,s+xSize);
    rrrx=zeros(1,s+xSize);
    cccx=zeros(1,s+xSize);
    pppx(1:xSize)=pxbest;pppx(xSize+1:end)=flj(:,1)';
    rrrx(1:xSize)=rxbest;rrrx(xSize+1:end)=flj(:,2)';
    cccx(1:xSize)=cxbest;cccx(xSize+1:end)=flj(:,3)';
    xxbest=zeros(s+xSize,Activity);
    xxbest(1:xSize,:)=xbest;
    xxbest(xSize+1:end,:)=fljx;
   
    % choose out non-dominated solution
    flj=[];
    fljx=[];
    k=0;
    tolt=1;
    tolc=10;
    tole=1;
    for i=1:xSize+s
        flag=0;
        
        for j=1:xSize+s 
            if j~=i
                if ((pppx(i)>pppx(j)) && (rrrx(i)>rrrx(j)) && (cccx(i)>cccx(j))) || ((abs(pppx(i)-pppx(j))<tolt) && (rrrx(i)>rrrx(j)) && (cccx(i)>cccx(j))) || ((pppx(i)>pppx(j)) && (abs(rrrx(i)-rrrx(j))<tole)&&  (cccx(i)>cccx(j))||((pppx(i)>pppx(j)) &&  (abs(cccx(i)-cccx(j))<tolc)&&  (rrrx(i)>rrrx(j))))
                    flag=1;
                    break;
                end
            end
        end
       
        if flag==0
            k=k+1;
            flj(k,1)=pppx(i);flj(k,2)=rrrx(i);flj(k,3)=cccx(i);%record the non-dominated solution
            fljx(k,:)=xxbest(i,:);
        end
    end
    
    % get rid of repeat solution
    repflag=0;   
    k=1;         
    flj2=[];     
    fljx2=[];    
    flj2(k,:)=flj(1,:);
    fljx2(k,:)=fljx(1,:);
    for j=2:size(flj,1)
        repflag=0;  
        for i=1:size(flj2,1)
            result=(fljx(j,:)==fljx2(i,:));
            if length(find(result==1))==Activity
                repflag=1;
            end
        end
        
        if repflag==0 
            k=k+1;
            flj2(k,:)=flj(j,:);
            fljx2(k,:)=fljx(j,:);
        end
        
    end
    
    % updata present Pareto solution
    flj=flj2;
    fljx=fljx2;
    Data{xh}=flj;
    Data2{xh}=Combination(fljx,:);
    No_Pareto{iter}=[size(flj,1)];
    ObjectiveAverage{iter}=[mean(flj(:,1)),mean(flj(:,2)),mean(flj(:,3))];
    ObjectiveBest{iter}=[min(flj(:,1)),min(flj(:,2)),min(flj(:,3))];
    
%% stop replication M
    if iter>M
    if isequal(No_Pareto{iter-19},No_Pareto{iter-18},No_Pareto{iter-17},No_Pareto{iter-16},No_Pareto{iter-15},No_Pareto{iter-14},No_Pareto{iter-13},No_Pareto{iter-12},No_Pareto{iter-11},No_Pareto{iter-10},No_Pareto{iter-9},No_Pareto{iter-8},No_Pareto{iter-7},No_Pareto{iter-6},No_Pareto{iter-5},No_Pareto{iter-4},No_Pareto{iter-3},No_Pareto{iter-2},No_Pareto{iter-1},No_Pareto{iter})==1 ...
       && isequal(ObjectiveAverage{iter-19},ObjectiveAverage{iter-18},ObjectiveAverage{iter-17},ObjectiveAverage{iter-16},ObjectiveAverage{iter-15},ObjectiveAverage{iter-14},ObjectiveAverage{iter-13},ObjectiveAverage{iter-12},ObjectiveAverage{iter-11},ObjectiveAverage{iter-10},ObjectiveAverage{iter-9},ObjectiveAverage{iter-8},ObjectiveAverage{iter-7},ObjectiveAverage{iter-6},ObjectiveAverage{iter-5},ObjectiveAverage{iter-4},ObjectiveAverage{iter-3},ObjectiveAverage{iter-2},ObjectiveAverage{iter-1},ObjectiveAverage{iter})==1 ...
       && isequal(ObjectiveBest{iter-19},ObjectiveBest{iter-18},ObjectiveBest{iter-17},ObjectiveBest{iter-16},ObjectiveBest{iter-15},ObjectiveBest{iter-14},ObjectiveBest{iter-13},ObjectiveBest{iter-12},ObjectiveBest{iter-11},ObjectiveBest{iter-10},ObjectiveBest{iter-9},ObjectiveBest{iter-8},ObjectiveBest{iter-7},ObjectiveBest{iter-6},ObjectiveBest{iter-5},ObjectiveBest{iter-4},ObjectiveBest{iter-3},ObjectiveBest{iter-2},ObjectiveBest{iter-1},ObjectiveBest{iter})==1
        nochangeiter=1;
    else
        nochangeiter=0;
    end
    end  
    if nochangeiter==1
        break
    end     
end
time=toc;
save(['Results_DESPSO_30_500_20_',num2str(c1),'.mat']);    

